%define	majorx    2
%define libnamex  %mklibname mysqlcppconnx %{majorx}

%define major     10
%define libname   %mklibname mysqlcppconn %{major}

%define develname %mklibname mysqlcppconn -d

%ifarch aarch64
%global _smp_ncpus_max 4
%endif

Summary:	A MySQL database connector for C++
Name:		mysql-connector-c++
Version:	9.2.0
Release:	%mkrel 1
Group:		System/Libraries
License:	GPLv2
URL:		https://dev.mysql.com/downloads/connector/cpp/
Source0:	https://dev.mysql.com/get/Downloads/Connector-C++/%{name}-%{version}-src.tar.gz
## from opensuse
Patch3:		mysql-connector-cpp-libmysql_dynamic_proxy_typos.patch
Patch4:		mysql-connector-cpp-mariadb.patch
Patch7:		mysql-connector-cpp-test-feature.patch
Patch8:		mysql-connector-cpp-protobuf-30.patch

BuildRequires:	cmake
BuildRequires:	cmake(rapidjson)
BuildRequires:	mysql-devel
BuildRequires:	pkgconfig(liblz4)
BuildRequires:	pkgconfig(libzstd)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	pkgconfig(zlib)

%description
MySQL Connector/C++ is a MySQL database connector for C++ development. The
MySQL driver for C++ can be used to connect to MySQL from C++ applications. The
driver mimics the JDBC 4.0 API. It implements a significant subset of JDBC 4.0.

The Driver for C++ is designed to work best with MySQL 5.1 or later. Note - its
full functionality is not available when connecting to MySQL 5.0. You cannot
connect to MySQL 4.1 or earlier.

Using MySQL Connector/C++ instead of the MySQL C API (MySQL Client Library)
offers the following advantages for C++ users:

    * Convenience of pure C++ - no C function calls
    * Support of a well designed API - JDBC 4.0
    * Support of a commonly known and well documented API - JDBC 4.0
    * Support of the object oriented programming paradigm
    * Shorter development times

%package -n	%{libname}
Summary:	The shared mysql-connector-cpp library
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}
Provides:	mysql-connector-cpp = %{version}-%{release}

%description -n	%{libname}
MySQL Connector/C++ is a MySQL database connector for C++ development. The
MySQL driver for C++ can be used to connect to MySQL from C++ applications. The
driver mimics the JDBC 4.0 API. It implements a significant subset of JDBC 4.0.

The Driver for C++ is designed to work best with MySQL 5.1 or later. Note - its
full functionality is not available when connecting to MySQL 5.0. You cannot
connect to MySQL 4.1 or earlier.

Using MySQL Connector/C++ instead of the MySQL C API (MySQL Client Library)
offers the following advantages for C++ users:

    * Convenience of pure C++ - no C function calls
    * Support of a well designed API - JDBC 4.0
    * Support of a commonly known and well documented API - JDBC 4.0
    * Support of the object oriented programming paradigm
    * Shorter development times

%package -n     %{libnamex}
Summary:        The shared mysql-connector-cpp library
Group:          System/Libraries

%description -n %{libnamex}
MySQL Connector/C++ is a MySQL database connector for C++ development. The
MySQL driver for C++ can be used to connect to MySQL from C++ applications. The
driver mimics the JDBC 4.0 API. It implements a significant subset of JDBC 4.0.

The Driver for C++ is designed to work best with MySQL 5.1 or later. Note - its
full functionality is not available when connecting to MySQL 5.0. You cannot
connect to MySQL 4.1 or earlier.

Using MySQL Connector/C++ instead of the MySQL C API (MySQL Client Library)
offers the following advantages for C++ users:

    * Convenience of pure C++ - no C function calls
    * Support of a well designed API - JDBC 4.0
    * Support of a commonly known and well documented API - JDBC 4.0
    * Support of the object oriented programming paradigm
    * Shorter development times

%package -n	%{develname}
Summary:	Development library and header files for development with mysql-connector-cpp
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libnamex} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	mysql-connector-cpp-devel = %{version}-%{release}
Obsoletes:	%{_lib}mysqlcppconn8-devel < 8.0.32-4

%description -n	%{develname}
MySQL Connector/C++ is a MySQL database connector for C++ development. The
MySQL driver for C++ can be used to connect to MySQL from C++ applications. The
driver mimics the JDBC 4.0 API. It implements a significant subset of JDBC 4.0.

The Driver for C++ is designed to work best with MySQL 5.1 or later. Note - its
full functionality is not available when connecting to MySQL 5.0. You cannot
connect to MySQL 4.1 or earlier.

Using MySQL Connector/C++ instead of the MySQL C API (MySQL Client Library)
offers the following advantages for C++ users:

    * Convenience of pure C++ - no C function calls
    * Support of a well designed API - JDBC 4.0
    * Support of a commonly known and well documented API - JDBC 4.0
    * Support of the object oriented programming paradigm
    * Shorter development times

%prep
%autosetup -p1 -n %{name}-%{version}-src

chmod -x jdbc/examples/*.{cpp,txt}

# drop bundled stuff
rm -rf cdk/extra/protobuf/protobuf-*/
rm -rf cdk/extra/rapidjson/include/
rm -rf cdk/extra/lz4/
rm -rf cdk/extra/zlib/
rm -rf cdk/extra/zstd/

# Save examples to keep directory clean (for doc)
cp -apr jdbc/examples examples
rm -rf examples/CMakeLists.txt

%build
export CXXFLAGS="%{build_cxxflags} -Wno-deprecated-declarations"
%cmake \
  -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
  -DMYSQL_INCLUDE_DIR=%{_includedir}/mysql \
  -DMYSQL_LIB=%{_libdir}/libmysqlclient.so \
  -DBUNDLE_DEPENDENCIES=OFF \
  -DWITH_PROTOBUF=system \
  -DWITH_LZ4=system \
  -DWITH_SSL=system \
  -DWITH_ZLIB=system \
  -DWITH_ZSTD=system \
  -DWITH_JDBC=ON \
  -DMYSQLCLIENT_STATIC_BINDING=OFF \
  -DMYSQLCLIENT_STATIC_LINKING=OFF \
  -DDEBUG_PREFIX_MAP=OFF
%cmake_build

%install
%cmake_install

mv -f %{buildroot}%{_prefix}/INFO_* .

# cmake package config file appears to be broken in multiple ways
rm -rf %{buildroot}%{_prefix}/*.cmake

%files -n %{libnamex}
%license LICENSE* INFO_BIN
%{_libdir}/libmysqlcppconnx.so.%{majorx}{,.*}

%files -n %{libname}
%license LICENSE* INFO_BIN
%{_libdir}/libmysqlcppconn.so.%{major}{,.*}

%files -n %{develname}
%doc README* CONTRIBUTING* examples
%{_includedir}/mysqlx/
%{_includedir}/jdbc/
%{_includedir}/mysql/jdbc.h
%{_libdir}/libmysqlcppconn.so
%{_libdir}/libmysqlcppconnx.so


%changelog
* Mon Mar 17 2025 daviddavid <daviddavid> 9.2.0-1.mga10
+ Revision: 2165535
- new version: 9.2.0
- rebuild for new protobuf 30.0
- rebuild for new protobuf 30.0

* Mon Jan 23 2023 wally <wally> 8.0.32-3.mga9
+ Revision: 1935123
- drop unneeded system protobuf patch

* Mon Jan 23 2023 wally <wally> 8.0.32-2.mga9
+ Revision: 1935119
- fix system protobuf patch

* Sun Jan 22 2023 daviddavid <daviddavid> 8.0.32-1.mga9
+ Revision: 1934897
- new version: 8.0.32
- use system zstd, zlib and lz4
- rediff mariadb and system-protobuf patches

* Thu Dec 22 2022 wally <wally> 8.0.28-3.mga9
+ Revision: 1925794
- rebuild for protobuf 21.12

* Sat Apr 02 2022 umeabot <umeabot> 8.0.28-2.mga9
+ Revision: 1841186
- Mageia 9 Mass Rebuild

* Sat Jan 22 2022 neoclust <neoclust> 8.0.28-1.mga9
+ Revision: 1769467
- New version 8.0.28: Fixes CVE-2021-371[12] (mga#29923)

* Thu Dec 30 2021 wally <wally> 8.0.27-1.mga9
+ Revision: 1765446
- new version 8.0.27
- rebuild for protobuf 3.19.1
- rebuild for openssl 3.0.0

* Mon Aug 16 2021 wally <wally> 8.0.26-2.mga9
+ Revision: 1741608
- build legacy JDBC API

* Mon Aug 16 2021 wally <wally> 8.0.26-1.mga9
+ Revision: 1741585
- new version 8.0.26

* Sat Feb 15 2020 umeabot <umeabot> 1.1.9-4.mga8
+ Revision: 1527013
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Tue Jul 09 2019 wally <wally> 1.1.9-3.mga8
+ Revision: 1419766
- add openSUSE patches to fix mysql-workbench connections to mariadb (mga#25071)

* Sun Sep 23 2018 umeabot <umeabot> 1.1.9-2.mga7
+ Revision: 1299662
- Mageia 7 Mass Rebuild

* Sat Dec 23 2017 wally <wally> 1.1.9-1.mga7
+ Revision: 1184322
- new version 1.1.9 (by kekePower)
- rebuild for new mariadb

* Fri Apr 28 2017 neoclust <neoclust> 1.1.8-1.mga6
+ Revision: 1097975
- New version 1.1.8

* Fri Feb 12 2016 umeabot <umeabot> 1.1.6-2.mga6
+ Revision: 956192
- Mageia 6 Mass Rebuild

* Mon Sep 14 2015 barjac <barjac> 1.1.6-1.mga6
+ Revision: 879272
- add cmake directive for mysql include path
- fix license
- tidy mixed tabs/spaces
- remove unused patch
+ spuhler <spuhler>
- removed the FindMySQL_cmake.patch
  * build should find it
- upgrade to vers 1.1.6

* Fri Feb 20 2015 spuhler <spuhler> 1.1.5-1.mga5
+ Revision: 816158
- added FindMySQL_cmake.patch to make it find mysql.h
- removed %%{__sed} -i -e 's/lib$/%%{_lib}/' driver/CMakeLists.txt
  * added it into the cmake options
  * used macros in the cmak options
- upgrade to ver. 1.1.5
- added patches from archlinux
- update to vers. 1.1.3
 * this increase the major from 6 to 7
- added discriptions from Opensuse

* Wed Oct 15 2014 umeabot <umeabot> 1.1.1-7.mga5
+ Revision: 746473
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.1.1-6.mga5
+ Revision: 727437
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.1.1-5.mga5
+ Revision: 682723
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 1.1.1-4.mga4
+ Revision: 529561
- Mageia 4 Mass Rebuild

* Wed Jul 10 2013 fwang <fwang> 1.1.1-3.mga4
+ Revision: 452471
- rebuild for new boost

* Sat Jan 12 2013 umeabot <umeabot> 1.1.1-2.mga3
+ Revision: 360579
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Oct 18 2012 fwang <fwang> 1.1.1-1.mga3
+ Revision: 307860
- update file list
- new version 1.1.1

* Thu Mar 24 2011 dmorgan <dmorgan> 1.1.0-0.7.bzr916.mga1
+ Revision: 77077
- Rebuild against new mysql

* Mon Feb 28 2011 dmorgan <dmorgan> 1.1.0-0.6.bzr916.mga1
+ Revision: 61364
- Workaround install pb
- New snapshot
  Fix file list
- Remove patch0, this is not the good way to fix
- Remove old patches
  Add patch to _start_ to fix build
- Add boost-devel as builrequire
- Update to 1.1.0 snapshot

* Tue Feb 22 2011 dmorgan <dmorgan> 1.0.5-7.mga1
+ Revision: 56414
- Remove mdv macros
- imported package mysql-connector-c++


* Mon Dec 06 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.5-7mdv2011.0
+ Revision: 612974
- the mass rebuild of 2010.1 packages

* Tue Apr 20 2010 Funda Wang <fwang@mandriva.org> 1.0.5-6mdv2010.1
+ Revision: 536927
- specify libdir
- use cmake standard macro

* Thu Feb 18 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.5-1mdv2010.1
+ Revision: 507862
- import mysql-connector-c++


* Thu Feb 18 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.5-1mdv2010.0
- initial Mandriva package (inspired by opensuse)
